angular.module('demoController', []).controller('LocationCtrl', ['$scope', '$http', 'Rest', function($scope, $http, Rest) {

    Rest.loadSchemaKey('http://localhost:8081/app/schemas/location.json', $scope, "schemaObject")

    // Set default ng-include html template
    $scope.templateUrl = 'location/createLocation.html'
    $scope.setTemplate = function(template) {
        $scope.templateUrl = template
    }

    $scope.operations = [{
        template: "location/createLocation.html",
        name: "Create"
    }, {
        template: "location/getLocation.html",
        name: "Get"
    }, {
        template: "location/updateLocation.html",
        name: "Update"
    }, {
        template: "location/deleteLocation.html",
        name: "Delete"
    }]

    $scope.get = function() {
        console.log("Calling GET Location...");
        Rest.doPost('http://localhost:8081/get', $scope.schemaObject, $scope , "response");
    }

    $scope.create = function() {
        console.log("Calling CREATE Location...");
        Rest.doPost('http://localhost:8081/create', $scope.schemaObject, $scope, "response");
    }

    $scope.update = function() {
        console.log("Calling UPDATE Location...");
        Rest.doPost('http://localhost:8081/update', $scope.schemaObject, $scope, "response");
    }

    $scope.remove = function() {
        console.log("Calling DELETE Location...");
        Rest.doPost('http://localhost:8081/delete', $scope.schemaObject, $scope, "response");
    }

    $scope.isEmpty = function() {
    	return !$scope.schemaObject.location.id;
    }

}]);


