angular.module('restService', [])

.factory('Rest', function($http) {

    return {

        doPost: function(path, obj, scope, key) {

            blockUI();

            var req = {
                method: 'POST',
                url: path,
                headers: {
                    'Content-Type': 'application/json'
                },
                data: JSON.stringify(obj)
            };

            $http(req)
                .success(function(response) {
                    if (response.success) {
                        console.log(response.data);
                        scope[key] = response.data;

                        if(req.url.includes('create')){
                            scope.schemaObject.location.id = Number(response.data.id);
                            scope.schemaObject.location.version = Number(response.data.version);
                        }
                        if(req.url.includes('get') && !(response.data.OutputParameters.P_LOCATIONS)){
                        	 bootbox.alert('Location not found');                       
                        }
                        if(response.message){
                            bootbox.alert(response.message);
                        }
                    } else {
                        bootbox.alert(response.message);
                    }
                })
                .catch(function(err) {
                    bootbox.alert(err.data);
                    scope.exception = err.data;
                })
                .finally(function() {
                    unblockUI();
                })
        },

        loadSchemaKey: function(path, scope, key) {
            var req = {
                method: 'GET',
                url: path,
                headers: {
                    'Content-Type': 'application/json'
                }
            }
            $http(req).then(function successCallback(response) {
                scope[key] = response.data
            }, function errorCallback(response) {
                console.log("ERROR LOADING SCHEMA")
            });
        }

    }

    function isUndefinedOrEmpty(obj) {
        return (typeof obj === "undefined" || obj === "")
    }

    function blockUI() {
        var message = "Processing...";
        var loaderUrl = "http://i.giphy.com/lijuimVKUcwRa.gif";
        $('html').block({
            message: '<h4>' + message + '<br><br><img src=' + loaderUrl + 'height=32 width=32/></h4>',
            overlayCSS: {
                backgroundColor: '#000',
                opacity: 0.2,
                cursor: 'wait',
                fadeIn: 0
            },
            css: {
                padding: 20,
                margin: 0,
                top: '50%',
                left: '50%',
                width: '250px',
                textAlign: 'center',
                color: '#000',
                border: '0px solid #aaa',
                cursor: 'wait',
                '-webkit-border-radius': '5px',
                '-moz-border-radius': '5px',
            }
        });
    }

    function unblockUI() {
        $('html').unblock();
    }
});